/*******************************************************************************
 * Copyright (c) 2005 Chris Aniszczyk.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Chris Aniszczyk - updated to work with EMF
 *    IBM Corporation
 *******************************************************************************/

package org.eclipse.gef.examples.shapes.emf.model;

import org.eclipse.emf.ecore.EObject;

/** @model */
public interface Connection extends EObject{

	public static final Boolean SOLID = Boolean.FALSE;
	public static final Boolean DASHED = Boolean.TRUE;
	
	/** @model */
	public Shape getSource();
	
	/**
	 * Sets the value of the '{@link org.eclipse.gef.examples.shapes.emf.model.Connection#getSource <em>Source</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Source</em>' reference.
	 * @see #getSource()
	 * @generated
	 */
	void setSource(Shape value);

	/** @model */
	public Shape getTarget();
	
	/**
	 * Sets the value of the '{@link org.eclipse.gef.examples.shapes.emf.model.Connection#getTarget <em>Target</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Target</em>' reference.
	 * @see #getTarget()
	 * @generated
	 */
	void setTarget(Shape value);

	/** @model default="false" */
	public boolean isDashed();

	/**
	 * Sets the value of the '{@link org.eclipse.gef.examples.shapes.emf.model.Connection#isDashed <em>Dashed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dashed</em>' attribute.
	 * @see #isDashed()
	 * @generated
	 */
	void setDashed(boolean value);

}
